DonorPerfect
===============

This module provides integration between Drupal and DonorPerfect (a CRM
for nonprofit organizations -- https://donorperfect.com).

CONTENTS OF THIS FILE
---------------------
* Features
* Usage Requirements
* Installation Requirements
* Installation
* Post-Installation
* Sponsors

FEATURES
------------
* Makes DonorPerfect Donors, Gifts, Contacts, and Other Info accessible to Drupal
  as entities for use in Views or by custom modules. All data for these entities
  remains stored in DonorPerfect (not in the Drupal database) and is queried
  dynamically through the DonorPerfect XML API. However, the module does locally
  store (in the Drupal database) a cache of metadata about DonorPerfect fields
  (basically the information about fields that can be found in DonorPerfect
  Screen Designer and Code Maintenance).
* Provides Name, Address, Email, and Phone form elements for use by custom modules.
  The Name element will perform an ajax search of DonorPerfect using the name
  entered, provide the user with a list of possible matches, and if a match is
  selected, will populate the Address, Email, and Phone elements.
* Provides the DPQuery object which can be used by custom modules to execute any
  of DonorPerfect XML API's predefined procedures or execute custom SQL queries
  on the DonorPerfect database.

USAGE REQUIREMENTS
------------
In order to use this module, you must have a DonorPerfect account with access to
the XML API enabled. You will need to enter a DonorPerfect username and password
into the module settings, or preferably, an API key provided by your DonorPerfect
representative.

INSTALLATION REQUIREMENTS
------------
In addition to the Datetime and Options core modules, this module requires the
[Entity API](https://drupal.org/project/entity) and
[Address](https://drupal.org/project/address) contributed modules.

INSTALLATION
------------
1. Copy this module's folder into your Drupal file structure, and then enable
   the DonorPerfect Base, Donor, Gift, Contact, and Other Info modules.
2. Go to the settings page (/admin/donorperfect/settings) and enter your API
   credentials (either a username and password, or preferably, an API key).
   Click the 'Save configuration' button at the bottom of the form to save your
   API credentials.
3. After you have saved your API credentials, click the button in the
   'DonorPerfect Cache' dropdown to populate the local metadata cache as
   described in the Features section above.
4. Also on the settings page, use the 'Drupal Entity Settings' fieldset to select
   which DonorPerfect fields should be included on the Drupal entities. The fields
   selected here will be the fields available when creating Views or when loading
   entities in custom modules.
5. Configure permissions. In order to use the search functionality on the Name
   form element as described in the Features section above, the Drupal user must
   have the 'Use DonorPerfect' permission.


POST-INSTALLATION
------------
* After the Installation steps are complete, you can start creating Views to
  display your DonorPerfect data in all kinds of ways. Of course, you don't want
  to expose private donor data in a publicly accessible View, so make sure to set
  proper access restrictions on any Views you create!
* You can also create a custom module to start utilizing the form elements and
  DPQuery object provided by this module.

SPONSORS
------------
Many thanks to [Healing Hands International](https://www.hhi.org) for sponsoring
the development of this module!
